#!/bin/bash
ROSETTABIN="/proj/wallner/users/x_bjowa/github/Rosetta/main/source/bin/"
ROSETTARELAX="/proj/wallner/users/x_bjowa/github/Rosetta/main/source/bin/relax.default.linuxgccrelease"ROSETTADB="/proj/wallner/users/x_bjowa/github/Rosetta/main/database/"
OUTPUTDIR="./docking_models"
DBPARA="-database $ROSETTADB"
PARTNERSPARA="-docking:partners A_B"
OTHERPARA="-ignore_zero_occupancy"
OUTPUTPARA="-out:file:silent $OUTPUTDIR/$base.silent  -out:file:scorefile $OUTPUTDIR/$base.sc"
DOCKPARA="-dock_pert 5 12 -nstruct 1000"

$ROSETTARELAX -database $ROSETTADB -in:file:s /home/clami66/interpred/fasta/target1_0___target2_0___pdb1my7_B_pdb1my7_A.pdb -relax:constrain_relax_to_start_coords -nstruct 1 -out:pdb -out:path:pdb $OUTPUTDIR
$ROSETTABIN/docking_protocol.default.linuxgccrelease $DBPARA -in:file:s $OUTPUTDIR/target1_0___target2_0___pdb1my7_B_pdb1my7_A_0001.pdb -out:file:silent $OUTPUTDIR/target1_0___target2_0___pdb1my7_B_pdb1my7_A.silent  -out:file:scorefile $OUTPUTDIR/target1_0___target2_0___pdb1my7_B_pdb1my7_A.sc $PARTNERSPARA $DOCKPARA $OUTPUTPARA $OTHERPARA
$ROSETTARELAX -database $ROSETTADB -in:file:s /home/clami66/interpred/fasta/target1_0___target2_0___pdb2cxk_C_pdb2cxk_A.pdb -relax:constrain_relax_to_start_coords -nstruct 1 -out:pdb -out:path:pdb $OUTPUTDIR
$ROSETTABIN/docking_protocol.default.linuxgccrelease $DBPARA -in:file:s $OUTPUTDIR/target1_0___target2_0___pdb2cxk_C_pdb2cxk_A_0001.pdb -out:file:silent $OUTPUTDIR/target1_0___target2_0___pdb2cxk_C_pdb2cxk_A.silent  -out:file:scorefile $OUTPUTDIR/target1_0___target2_0___pdb2cxk_C_pdb2cxk_A.sc $PARTNERSPARA $DOCKPARA $OUTPUTPARA $OTHERPARA
$ROSETTARELAX -database $ROSETTADB -in:file:s /home/clami66/interpred/fasta/target1_0___target2_0___pdb2cxk_E_pdb2cxk_D.pdb -relax:constrain_relax_to_start_coords -nstruct 1 -out:pdb -out:path:pdb $OUTPUTDIR
$ROSETTABIN/docking_protocol.default.linuxgccrelease $DBPARA -in:file:s $OUTPUTDIR/target1_0___target2_0___pdb2cxk_E_pdb2cxk_D_0001.pdb -out:file:silent $OUTPUTDIR/target1_0___target2_0___pdb2cxk_E_pdb2cxk_D.silent  -out:file:scorefile $OUTPUTDIR/target1_0___target2_0___pdb2cxk_E_pdb2cxk_D.sc $PARTNERSPARA $DOCKPARA $OUTPUTPARA $OTHERPARA
$ROSETTARELAX -database $ROSETTADB -in:file:s /home/clami66/interpred/fasta/target1_0___target2_0___pdb2cxk_A_pdb2cxk_C.pdb -relax:constrain_relax_to_start_coords -nstruct 1 -out:pdb -out:path:pdb $OUTPUTDIR
$ROSETTABIN/docking_protocol.default.linuxgccrelease $DBPARA -in:file:s $OUTPUTDIR/target1_0___target2_0___pdb2cxk_A_pdb2cxk_C_0001.pdb -out:file:silent $OUTPUTDIR/target1_0___target2_0___pdb2cxk_A_pdb2cxk_C.silent  -out:file:scorefile $OUTPUTDIR/target1_0___target2_0___pdb2cxk_A_pdb2cxk_C.sc $PARTNERSPARA $DOCKPARA $OUTPUTPARA $OTHERPARA
$ROSETTARELAX -database $ROSETTADB -in:file:s /home/clami66/interpred/fasta/target1_0___target2_0___pdb2cxk_D_pdb2cxk_E.pdb -relax:constrain_relax_to_start_coords -nstruct 1 -out:pdb -out:path:pdb $OUTPUTDIR
$ROSETTABIN/docking_protocol.default.linuxgccrelease $DBPARA -in:file:s $OUTPUTDIR/target1_0___target2_0___pdb2cxk_D_pdb2cxk_E_0001.pdb -out:file:silent $OUTPUTDIR/target1_0___target2_0___pdb2cxk_D_pdb2cxk_E.silent  -out:file:scorefile $OUTPUTDIR/target1_0___target2_0___pdb2cxk_D_pdb2cxk_E.sc $PARTNERSPARA $DOCKPARA $OUTPUTPARA $OTHERPARA
$ROSETTARELAX -database $ROSETTADB -in:file:s /home/clami66/interpred/fasta/target1_0___target2_0___pdb1my7_A_pdb1my7_B.pdb -relax:constrain_relax_to_start_coords -nstruct 1 -out:pdb -out:path:pdb $OUTPUTDIR
$ROSETTABIN/docking_protocol.default.linuxgccrelease $DBPARA -in:file:s $OUTPUTDIR/target1_0___target2_0___pdb1my7_A_pdb1my7_B_0001.pdb -out:file:silent $OUTPUTDIR/target1_0___target2_0___pdb1my7_A_pdb1my7_B.silent  -out:file:scorefile $OUTPUTDIR/target1_0___target2_0___pdb1my7_A_pdb1my7_B.sc $PARTNERSPARA $DOCKPARA $OUTPUTPARA $OTHERPARA
$ROSETTARELAX -database $ROSETTADB -in:file:s /home/clami66/interpred/fasta/target1_0___target2_0___pdb2cxk_A_pdb2cxk_B.pdb -relax:constrain_relax_to_start_coords -nstruct 1 -out:pdb -out:path:pdb $OUTPUTDIR
$ROSETTABIN/docking_protocol.default.linuxgccrelease $DBPARA -in:file:s $OUTPUTDIR/target1_0___target2_0___pdb2cxk_A_pdb2cxk_B_0001.pdb -out:file:silent $OUTPUTDIR/target1_0___target2_0___pdb2cxk_A_pdb2cxk_B.silent  -out:file:scorefile $OUTPUTDIR/target1_0___target2_0___pdb2cxk_A_pdb2cxk_B.sc $PARTNERSPARA $DOCKPARA $OUTPUTPARA $OTHERPARA
$ROSETTARELAX -database $ROSETTADB -in:file:s /home/clami66/interpred/fasta/target1_0___target2_0___pdb2cxk_C_pdb2cxk_D.pdb -relax:constrain_relax_to_start_coords -nstruct 1 -out:pdb -out:path:pdb $OUTPUTDIR
$ROSETTABIN/docking_protocol.default.linuxgccrelease $DBPARA -in:file:s $OUTPUTDIR/target1_0___target2_0___pdb2cxk_C_pdb2cxk_D_0001.pdb -out:file:silent $OUTPUTDIR/target1_0___target2_0___pdb2cxk_C_pdb2cxk_D.silent  -out:file:scorefile $OUTPUTDIR/target1_0___target2_0___pdb2cxk_C_pdb2cxk_D.sc $PARTNERSPARA $DOCKPARA $OUTPUTPARA $OTHERPARA
$ROSETTARELAX -database $ROSETTADB -in:file:s /home/clami66/interpred/fasta/target1_0___target2_0___pdb2cxk_D_pdb2cxk_C.pdb -relax:constrain_relax_to_start_coords -nstruct 1 -out:pdb -out:path:pdb $OUTPUTDIR
$ROSETTABIN/docking_protocol.default.linuxgccrelease $DBPARA -in:file:s $OUTPUTDIR/target1_0___target2_0___pdb2cxk_D_pdb2cxk_C_0001.pdb -out:file:silent $OUTPUTDIR/target1_0___target2_0___pdb2cxk_D_pdb2cxk_C.silent  -out:file:scorefile $OUTPUTDIR/target1_0___target2_0___pdb2cxk_D_pdb2cxk_C.sc $PARTNERSPARA $DOCKPARA $OUTPUTPARA $OTHERPARA
$ROSETTARELAX -database $ROSETTADB -in:file:s /home/clami66/interpred/fasta/target1_0___target2_0___pdb2cxk_B_pdb2cxk_A.pdb -relax:constrain_relax_to_start_coords -nstruct 1 -out:pdb -out:path:pdb $OUTPUTDIR
$ROSETTABIN/docking_protocol.default.linuxgccrelease $DBPARA -in:file:s $OUTPUTDIR/target1_0___target2_0___pdb2cxk_B_pdb2cxk_A_0001.pdb -out:file:silent $OUTPUTDIR/target1_0___target2_0___pdb2cxk_B_pdb2cxk_A.silent  -out:file:scorefile $OUTPUTDIR/target1_0___target2_0___pdb2cxk_B_pdb2cxk_A.sc $PARTNERSPARA $DOCKPARA $OUTPUTPARA $OTHERPARA
